function [networkMatrix,Y] = plotNetworkMatrix_DLS_tr_Y(tr_results, tr_cl_results, dls_idxs, conf_th, show_confs, GenesAliases)
% [networkMatrix,Y] = plotNetworkMatrix_DLS_tr_Y(tr_results, tr_cl_results, dls_idxs, conf_th, tr_genes_agis, show_confs, GenesAliases);
%
% networkMatrix: sparse matrix where classNetworkMatrix(i,j) = 1 si
% link desde nodo i hasta nodo j.

    n_genes = numel(tr_results.genes_agis);
    n_dls = tr_cl_results.n_dls;
    if isempty(dls_idxs)
        dls_idxs = 1:n_dls;
    end
    Y = tr_results.dls{1}.Y_tr;
    
    % generate networkMatrix
    networkMatrix = sparse(n_genes,n_genes);
    for i = dls_idxs

        if ~tr_results.dls{i}.is_valid
            continue;
        end
        dls_idx = tr_results.dls{i}.dls_idx;
        
        Y(dls_idx) = 2;

        dls_nbors = find(tr_cl_results.preds.Confs_matrix(i,:) > conf_th);
        networkMatrix(dls_idx,dls_nbors) = tr_cl_results.preds.Confs_matrix(i,dls_nbors);

    end
    
    viewNetwork_DLS(networkMatrix,tr_results.genes_agis,show_confs,Y,GenesAliases);
    
end
