function [bg,networkMatrix,genesNames] = plotNetworkMatrix_DLS_tr_cl_Y(tr_results, cl_results, target_dls_idxs, conf_th, tr_genes_agis, cl_genes_agis, show_confs, GenesAliases)
% [bg,networkMatrix,genesNames] = plotNetworkMatrix_DLS_tr_cl_Y(tr_results, cl_results, conf_th, tr_genes_agis, cl_genes_agis, GenesAliases);
%
% networkMatrix: sparse matrix where classNetworkMatrix(i,j) = 1 si
% link desde nodo i hasta nodo j.

    n_tr_genes = numel(tr_genes_agis);
    n_cl_genes = numel(cl_genes_agis);
    n_genes = n_tr_genes + n_cl_genes;
    genes_agis = [tr_genes_agis; cl_genes_agis];
    
    n_dls = numel(cl_results.dls);
    if isempty(target_dls_idxs)
        dls_idxs = 1:n_dls;
    else
        dls_idxs = target_dls_idxs;
    end
    
    Y = [tr_results.dls{1}.Y_tr; zeros(n_cl_genes,1)];
    
    % generate networkMatrix
    networkMatrix = sparse(n_genes,n_genes);
    for i = dls_idxs

        if ~cl_results.dls{i}.is_valid
            continue;
        end
        dls_idx = tr_results.dls{i}.dls_idx;

        Y(dls_idx) = 2;
        
        dls_tr_nbors = find(tr_results.dls{i}.Confs > conf_th);
        networkMatrix(dls_idx,dls_tr_nbors) = tr_results.dls{i}.Confs(dls_tr_nbors);

        dls_cl_nbors = find(cl_results.dls{i}.Confs > conf_th);
        networkMatrix(dls_idx,n_tr_genes + dls_cl_nbors) = cl_results.dls{i}.Confs(dls_cl_nbors);

    end
    
    bg = viewNetwork_DLS(networkMatrix,genes_agis,show_confs,Y,GenesAliases);
    
end
