function printNetwork(networkMatrix,genesNames,th,filename)

    % delete genes without conections
    alone_rows = sum(networkMatrix,2) == 0;
    alone_cols = sum(networkMatrix,1) == 0;
    alone_genes = alone_rows & alone_cols';
    
    networkMatrix = networkMatrix(~alone_genes,~alone_genes);
    networkMatrix = networkMatrix - diag(diag(networkMatrix));
    genesNames = genesNames(~alone_genes);
    
    % open file to print the network
    fid = fopen(filename,'wt');
    
    % print
    n_genes = numel(genesNames);
    for i = 1:n_genes
        
        for j = 1:n_genes
            
            if networkMatrix(i,j) >= th
                fprintf(fid,'%s\t%.4f\t%s\n',genesNames{i},full(networkMatrix(i,j)),genesNames{j});
            end
            
        end
        
    end

    fclose(fid);
    
end