function bg = viewNetwork_DLS(networkMatrix,genes_agis,show_confs,Y,GenesAliases)
% bg = plotClassNetwork(classNetworkMatrix, GeneIds);
%
% networkMatrix: sparse matrix where classNetworkMatrix(i,j) = 1 si
% link desde nodo i hasta nodo j.
    
    if show_confs
        show_confs = 'on';
    else
        show_confs = 'off';
    end
    
    % delete genes without conections
    alone_rows = sum(networkMatrix,2) == 0;
    alone_cols = sum(networkMatrix,1) == 0;
    alone_genes = alone_rows & alone_cols';
    
    networkMatrix = networkMatrix(~alone_genes,~alone_genes);
    networkMatrix = networkMatrix - diag(diag(networkMatrix));
    genes_agis = genes_agis(~alone_genes);
    
    if isempty(genes_agis)
        disp('No interactions found.')
        return
    end
    
    % get genes names
    if exist('GenesAliases','var')
        genesNames = getGenesNames(genes_agis,GenesAliases,true);
    else
        genesNames = genes_agis;
    end
    
    if numel(unique(genesNames)) ~= numel(genesNames)
        genesNames = genes_agis;
    end
    
    bg = biograph(networkMatrix,genesNames,'LayoutType','equilibrium','EdgeType','straight','ShowWeights',show_confs);
    
%     set(bg.Edges,'LineWidth',1.2);
    bg.EdgeFontSize = 10;
    bg.EdgeTextColor = [0 0 1];
    bg.ArrowSize = 8;
%     bg.LayoutScale = 2;
    bg.Scale = 1;
    
    nedges = numel(bg.Edges);
    for i = 1:nedges
        weight = linealTransform(abs(bg.Edges(i).Weight), 1, 0, 0, 1);
        set(bg.Edges(i),'LineColor',repmat(weight,1,3));
    end
    
    set(bg.Nodes,'Shape','ellipse');
    set(bg.Nodes,'LineWidth',2);
    set(bg.Nodes,'LineColor',[0 0 0]);
    
    if exist('Y','var')
        
        Y = Y(~alone_genes);
        set(bg.Nodes(Y==1),'LineColor',[0 0 1]);
        set(bg.Nodes(Y==-1),'LineColor',[1 0 0]);
        set(bg.Nodes(Y==2),'LineColor',[0 1 0]);
        set(bg.Nodes(Y==3),'LineColor',[0 0 0]);
        
    end
    
    view(bg)
    
end
