function [new_confs,new_coexp] = Bayes_confidence(dls,X_new,sigma,min_coexp)
% Classifies new samples with bayesian inference
    
    min_coexp = 0.5;
    
    c1_mask = dls.Y_tr == 1;
    c0_mask = dls.Y_tr == -1;
    
    new_coexp = coexpression_real(dls.sample,full(X_new(:,dls.feats)))';
    if dls.is_abs
        new_coexp2 = abs(new_coexp);
        coexp_tr1 = abs(dls.coexp_tr(c1_mask));
        coexp_tr0 = abs(dls.coexp_tr(c0_mask));
    else
        new_coexp2 = new_coexp;
        coexp_tr1 = dls.coexp_tr(c1_mask);
        coexp_tr0 = dls.coexp_tr(c0_mask);
    end
    if nargin > 3
        new_coexp2 = new_coexp2.*sigmoid(new_coexp2, min_coexp, min_coexp-0.2, 1, 0);
    end
    
    L1 = ksdensity(coexp_tr1,new_coexp2,'width',sigma);
    L0 = ksdensity(coexp_tr0,new_coexp2,'width',sigma,'weights',dls.wclass0);
    
    p1 = numel(find(c1_mask))/numel(dls.Y_tr);
    p0 = 1-p1;
    
    L1 = L1.*p1;
    L0 = L0.*p0;
    
    new_confs = L1./(L1+L0);

end
