function [coexp,prods,sums] = coexpression_real(a,B,prods,feats)
% coexp = A./norm(A) * B./norm(B) = cos(angulo)
% Mide el coseno del ngulo entre los dos vectores.
    
    if nargin < 3
        ns = size(B,1);
        prods.co = repmat(a,ns,1).*B;
        prods.a = a.^2;
        prods.B = B.^2;
    elseif nargin > 3
        prods.co = prods.co(:,feats);
        prods.a = prods.a(feats);
        prods.B = prods.B(:,feats);
    end
    
    sums.sum_co = sum(prods.co,2);
    sums.norm_a = sum(prods.a,2).^(1/2);
    sums.norm_B = sum(prods.B,2).^(1/2);
	
    coexp = abs(sums.sum_co)./(sums.norm_a*sums.norm_B);
    
    coexp(isnan(coexp)) = 0;

end