function [sel_feats,scores,wclass0,FN_idxs] = dls_feature_selection(X,Y,dls_idx,dw,min_coexp,min_feats,max_feats,w1_feats_th,delta_w1,nFN,wFN,min_FN_coexp,sel_feats)
    
    p_nfa = 1.2;

    min_coexp_min = min_coexp-0.1;
    min_coexp_max = min_coexp;

    feats_th1 = 5;
    feats_th2 = 15;
    
    mask1 = Y == 1;
    mask0 = Y == -1;
    
    dls_mask = true(size(Y));
    dls_mask(dls_idx) = false;
    
    p = 0.2:0.2:1;
    n_p = numel(p);
    
    % compute the actual features score
    X = full(X);
    [coexp,prods] = coexpression_real(X(dls_idx,:),X);
    
    if nargin < 13
        sel_feats = true(1,size(X,2));
    else
        coexp = coexpression_real(X(dls_idx,:),X,prods,sel_feats);
    end
    
    nf = numel(find(sel_feats));
    
    % exclude nFN class0 samples with highest coexpression
    [wclass0,FN_idxs] = weight_class0(coexp,Y,nFN,wFN,min_FN_coexp);
    
    % compute score
%     min_coexp = sigmoid(nf, 15, 5, 0.4, 0.2);
%     coexp = sigmoid(coexp, 1, min_coexp, 1, 0);

    min_coexp = sigmoid(nf, feats_th2, feats_th1, min_coexp_max, min_coexp_min);
    coexp = norm_coexps2(coexp,min_coexp);
%     coexp = norm_coexps(mask1,mask0,coexp,min_coexp);
    
    score_pos = sum(coexp(mask1 & dls_mask));
    score_neg = sum(coexp(mask0).*wclass0);
    w1 = get_w1(nf,w1_feats_th,delta_w1);
    
%     score = w1*(score_pos - dw*score_neg);
    score = w1*score_pos - dw*score_neg;
    
    n_iters = 0;
    % select best features with stepwise feature selection
    while 1
        
        % evaluate each feature to add and delete
        n_iters = n_iters + 1;
        nfa = min(round(find(sel_feats,1,'last')*p_nfa),max_feats);
%         nfa = max_feats;
        feat_scores = eval_features(prods,Y,sel_feats,nfa,dw,min_feats,w1_feats_th,delta_w1,min_coexp_min,min_coexp_max,feats_th1,feats_th2,wclass0,dls_mask);
        
        % swap all features with higher score
        [feat_scores,sorted_idxs] = sort(feat_scores,'descend');
        swap_mask = feat_scores > score;
        swap_idxs = sorted_idxs(swap_mask);
        n_swaps = numel(swap_idxs);
        if n_swaps > 1
            
            % swap the all the p best
            sel_feats_all = cell(size(p));
            score_all = zeros(size(p));
            wclass0_all = cell(size(p));
            FN_idxs_all = cell(size(p));
            nf_all = zeros(size(p));
            for i = 1:n_p
                n_swaps_all = round(n_swaps*p(i));
                swap_idxs_all = swap_idxs(1:n_swaps_all);
                n_del = numel(find(sel_feats(swap_idxs_all)));
                n_add = n_swaps_all - n_del;
                max_n_del = nf + n_add - min_feats;
                nf_all(i) = nf-n_del+n_add;

                if nf_all(i) < min_feats
                    del_mask = sel_feats(swap_idxs_all);
                    del_idxs = swap_idxs_all(del_mask);
                    swap_idxs_all = setdiff(swap_idxs_all,del_idxs(max_n_del+1:end));
                end

                sel_feats_all{i} = sel_feats;
                sel_feats_all{i}(swap_idxs_all) = ~sel_feats_all{i}(swap_idxs_all);
                nf_all(i) = numel(find(sel_feats_all{i}));

                coexp = coexpression_real(nan,nan,prods,sel_feats_all{i});
                [wclass0_all{i},FN_idxs_all{i}] = weight_class0(coexp,Y,nFN,wFN,min_FN_coexp);

%                 min_coexp = sigmoid(nf_all(i), 15, 5, 0.4, 0.2);
%                 coexp = sigmoid(coexp, 1, min_coexp, 1, 0);

                min_coexp = sigmoid(nf_all(i), feats_th2, feats_th1, min_coexp_max, min_coexp_min);
                coexp = norm_coexps2(coexp,min_coexp);
%                 coexp = norm_coexps(mask1,mask0,coexp,min_coexp);

                w1 = get_w1(nf_all(i),w1_feats_th,delta_w1);
                
%                 score_all(i) = w1*(sum(coexp(mask1 & dls_mask)) - dw*sum(coexp(mask0).*wclass0_all{i}));
                score_all(i) = w1*sum(coexp(mask1 & dls_mask)) - dw*sum(coexp(mask0).*wclass0_all{i});
            end
            [score_all,idx] = max(score_all);
            sel_feats_all = sel_feats_all{idx};
            nf_all = nf_all(idx);
            wclass0_all = wclass0_all{idx};
            FN_idxs_all = FN_idxs_all{idx};
            
            % add
%             swap_idxs = sorted_idxs;
            
            sel_feats_add = cell(size(p));
            score_add = zeros(size(p));
            wclass0_add = cell(size(p));
            FN_idxs_add = cell(size(p));
            nf_add = zeros(size(p));
            add_mask = ~sel_feats(swap_idxs);
            add_idxs = swap_idxs(add_mask);
            n_add_idx = numel(add_idxs);
            for i = 1:n_p
%                 n_adds = round(n_add_idx*p(i));
                n_adds = min([round(nf*p(i)) n_add_idx]);
                if n_adds > 0
                    sel_feats_add{i} = sel_feats;
                    sel_feats_add{i}(add_idxs(1:n_adds)) = ~sel_feats_add{i}(add_idxs(1:n_adds));
                    nf_add(i) = numel(find(sel_feats_add{i}));

                    coexp = coexpression_real(nan,nan,prods,sel_feats_add{i});
                    [wclass0_add{i},FN_idxs_add{i}] = weight_class0(coexp,Y,nFN,wFN,min_FN_coexp);

%                     min_coexp = sigmoid(nf_add(i), 15, 5, 0.4, 0.2);
%                     coexp = sigmoid(coexp, 1, min_coexp, 1, 0);
                    
                    min_coexp = sigmoid(nf_add(i), feats_th2, feats_th1, min_coexp_max, min_coexp_min);
                    coexp = norm_coexps2(coexp,min_coexp);
%                     coexp = norm_coexps(mask1,mask0,coexp,min_coexp);

                    w1 = get_w1(nf_add(i),w1_feats_th,delta_w1);
%                     score_add(i) = w1*(sum(coexp(mask1 & dls_mask)) - dw*sum(coexp(mask0).*wclass0_add{i}));
                    score_add(i) = w1*sum(coexp(mask1 & dls_mask)) - dw*sum(coexp(mask0).*wclass0_add{i});
                else
                    score_add(i) = -Inf;
                end
            end
            [score_add,idx] = max(score_add);
            sel_feats_add = sel_feats_add{idx};
            nf_add = nf_add(idx);
            wclass0_add = wclass0_add{idx};
            FN_idxs_add = FN_idxs_add{idx};
            
            % del
            sel_feats_del = cell(size(p));
            score_del = zeros(size(p));
            wclass0_del = cell(size(p));
            FN_idxs_del = cell(size(p));
            nf_del = zeros(size(p));
            del_mask = sel_feats(swap_idxs);
            del_idxs = swap_idxs(del_mask);
            n_del_idx = numel(del_idxs);
            for i = 1:n_p
%                 n_dels = round(n_del_idx*p(i));
%                 n_dels = min(n_dels,nf - min_feats);
                n_dels = min([round(nf*p(i)) n_del_idx nf - min_feats]);
                if n_dels > 0
                    sel_feats_del{i} = sel_feats;
                    sel_feats_del{i}(del_idxs(1:n_dels)) = ~sel_feats_del{i}(del_idxs(1:n_dels));
                    nf_del(i) = numel(find(sel_feats_del{i}));

                    coexp = coexpression_real(nan,nan,prods,sel_feats_del{i});
                    [wclass0_del{i},FN_idxs_del{i}] = weight_class0(coexp,Y,nFN,wFN,min_FN_coexp);

%                     min_coexp = sigmoid(nf_del(i), 15, 5, 0.4, 0.2);
%                     coexp = sigmoid(coexp, 1, min_coexp, 1, 0);
                    
                    min_coexp = sigmoid(nf_del(i), feats_th2, feats_th1, min_coexp_max, min_coexp_min);
                    coexp = norm_coexps2(coexp,min_coexp);
%                     coexp = norm_coexps(mask1,mask0,coexp,min_coexp);
                    
                    w1 = get_w1(nf_del(i),w1_feats_th,delta_w1);
                    
%                     score_del(i) = w1*(sum(coexp(mask1 & dls_mask)) - dw*sum(coexp(mask0).*wclass0_del{i}));
                    score_del(i) = w1*sum(coexp(mask1 & dls_mask)) - dw*sum(coexp(mask0).*wclass0_del{i});
                else
                    score_del(i) = -Inf;
                end
            end
            [score_del,idx] = max(score_del);
            sel_feats_del = sel_feats_del{idx};
            nf_del = nf_del(idx);
            wclass0_del = wclass0_del{idx};
            FN_idxs_del = FN_idxs_del{idx};
            
        else
            score_all = -Inf;
            score_add = -Inf;
            score_del = -Inf;
        end
        
        % swap feature with highest score
        sel_feats_best = sel_feats;
        sel_feats_best(sorted_idxs(1)) = ~sel_feats_best(sorted_idxs(1));
        
        nf_best = numel(find(sel_feats_best));
        
        coexp = coexpression_real(nan,nan,prods,sel_feats_best);
        [wclass0_best,FN_idxs_best] = weight_class0(coexp,Y,nFN,wFN,min_FN_coexp);

%         min_coexp = sigmoid(nf_best, 15, 5, 0.4, 0.2);
%         coexp = sigmoid(coexp, 1, min_coexp, 1, 0);
        
        min_coexp = sigmoid(nf_best, feats_th2, feats_th1, min_coexp_max, min_coexp_min);
        coexp = norm_coexps2(coexp,min_coexp);
%         coexp = norm_coexps(mask1,mask0,coexp,min_coexp);
        
        w1 = get_w1(nf_best,w1_feats_th,delta_w1);
        
%         score_best = w1*(sum(coexp(mask1 & dls_mask)) - dw*sum(coexp(mask0).*wclass0_best));
        score_best = w1*sum(coexp(mask1 & dls_mask)) - dw*sum(coexp(mask0).*wclass0_best);
        
        [score,max_idx] = max([score score_all score_add score_del score_best]);
        
        % if score isn't better, end
        if max_idx == 2
            sel_feats = sel_feats_all;
            wclass0 = wclass0_all;
            FN_idxs = FN_idxs_all;
            nf = nf_all;
        elseif max_idx == 3
            sel_feats = sel_feats_add;
            wclass0 = wclass0_add;
            FN_idxs = FN_idxs_add;
            nf = nf_add;
        elseif max_idx == 4
            sel_feats = sel_feats_del;
            wclass0 = wclass0_del;
            FN_idxs = FN_idxs_del;
            nf = nf_del;
        elseif max_idx == 5
            sel_feats = sel_feats_best;
            wclass0 = wclass0_best;
            FN_idxs = FN_idxs_best;
            nf = nf_best;
        elseif max_idx == 1
            precW = 2;
			w1 = 1;
            min_coexp = sigmoid(nf, feats_th2, feats_th1, min_coexp_max, min_coexp_min);
            coexp = coexpression_real(nan,nan,prods,sel_feats);
            coexp = norm_coexps2(coexp,min_coexp);
            [scores.F,scores.score,scores.prec_e,scores.rec_e,scores.score_pos,scores.score_neg] = getScore(coexp,Y,dls_mask,wclass0,dw,w1,precW);
            break;
        end
        
    end

end

function feat_scores = eval_features(prods,Y,sel_feats,nfa,dw,min_feats,w1_feats_th,delta_w1,min_coexp_min,min_coexp_max,feats_th1,feats_th2,wclass0,dls_mask)
    
    nf = size(prods.co,2);
    
    [coexp_t,prods_t,sums] = coexpression_real(nan,nan,prods,sel_feats);
    
    nsf = numel(find(sel_feats));
    feat_scores = zeros(1,nf) - Inf;
    
    mask1 = Y == 1;
    mask0 = Y == -1;
    w1_add = get_w1(nsf+1,w1_feats_th,delta_w1);
    w1_del = get_w1(nsf-1,w1_feats_th,delta_w1);
    
%     min_coexp_add = sigmoid(nsf+1, 15, 5, 0.4, 0.2);
%     min_coexp_del = sigmoid(nsf-1, 15, 5, 0.4, 0.2);

    min_coexp_add = sigmoid(nsf+1, feats_th2, feats_th1, min_coexp_max, min_coexp_min);
    min_coexp_del = sigmoid(nsf-1, feats_th2, feats_th1, min_coexp_max, min_coexp_min);
    
    for i = 1:nfa
        
        if ~sel_feats(i)
            % evaluate features to add
            
            samples_coexp = coexpression_real_add(prods,sums,i);
            
%             samples_coexp = sigmoid(samples_coexp, 1, min_coexp_add, 1, 0);

            samples_coexp = norm_coexps2(samples_coexp,min_coexp_add);
%             samples_coexp = norm_coexps(mask1,mask0,samples_coexp,min_coexp_add);
            
            % get feature score
%             feat_scores(i) = w1_add*(sum(samples_coexp(mask1 & dls_mask)) - dw*sum(samples_coexp(mask0).*wclass0));
            feat_scores(i) = w1_add*sum(samples_coexp(mask1 & dls_mask)) - dw*sum(samples_coexp(mask0).*wclass0);
            
        elseif nsf > min_feats
            % evaluate features to delete
            
            samples_coexp = coexpression_real_del(prods,sums,i);
            
%             samples_coexp = sigmoid(samples_coexp, 1, min_coexp_del, 1, 0);
            
            samples_coexp = norm_coexps2(samples_coexp,min_coexp_del);
%             samples_coexp = norm_coexps(mask1,mask0,samples_coexp,min_coexp_del);

%             feat_scores(i) = w1_del*(sum(samples_coexp(mask1 & dls_mask)) - dw*sum(samples_coexp(mask0).*wclass0));
            feat_scores(i) = w1_del*sum(samples_coexp(mask1 & dls_mask)) - dw*sum(samples_coexp(mask0).*wclass0);
            
        end
        
    end

end

function [wclass0,FN_idxs] = weight_class0(coexp,Y,nFN,wFN,min_FN_coexp)

    if nFN > 0
        class0_idxs = find(Y == -1);
        class0_coexp = coexp(class0_idxs);
        wclass0 = ones(size(class0_coexp));

        [sorted_coexp,sorted_idxs0] = sort(class0_coexp,'descend');
        valid_FNs_mask = sorted_coexp > min_FN_coexp;
        sorted_idxs0 = sorted_idxs0(valid_FNs_mask);
        nFN = min(nFN,numel(sorted_idxs0));

        FN_idxs = class0_idxs(sorted_idxs0(1:nFN));
        wclass0(sorted_idxs0(1:nFN)) = wFN;
        
    else
        FN_idxs = [];
        wclass0 = ones(numel(find(Y == -1)),1);
    end

end

function w1 = get_w1(nfeats,w1_feats_th,delta_w1)

    if nfeats < w1_feats_th
        w1 = linealTransform(nfeats,w1_feats_th,w1_feats_th-1,1,1-delta_w1);
    else
        w1 = 1;
%         w1 = linealTransform(nfeats,max(max_feats/2,w1_feats_th),w1_feats_th,1,0.9);
%         w1 = linealTransform(nfeats,min(max_feats,w1_feats_th+100),w1_feats_th,1,0.9);
    end
    
end

function coexps = norm_coexps(mask1,mask0,coexps,min_coexp)
    
    coexps(mask1) = coexps(mask1).*sigmoid(coexps(mask1), 0.7, 0.5, 1, 0);
    coexps(mask0) = sigmoid(coexps(mask0), 1, min_coexp, 1, 0);
    
%     coexps(mask1) = sigmoid(coexps(mask1), 1, min_coexp1, 1, 0);
%     coexps(mask0) = sigmoid(coexps(mask0), 1, min_coexp0, 1, 0);

end

function coexps = norm_coexps2(coexps,min_coexp)
    
    coexps = sigmoid(coexps, 1, min_coexp, 1, 0);
    
%     coexps(mask1) = coexps(mask1).*sigmoid(coexps(mask1), min_coexp1+0.2, min_coexp1, 1, 0);
%     coexps(mask0) = coexps(mask0).*sigmoid(coexps(mask0), min_coexp0+0.2, min_coexp0, 1, 0);

end

