function dls = dls_train(X,Y,pvals,pval_th,dls_idx,dw,min_coexp,min_feats,w1_feats_th_prctile,min_w1,dls_min_score,nFN,min_FN_coexp)
    
	min_score_pos = 0.5;
	
    % filter features with value 0 in the dls sample
    sel_feats_abs = pvals(dls_idx,:) <= pval_th;
    total_feats = size(X,2);
    avail_feats = find(sel_feats_abs);
    dls.avail_feats = avail_feats;
    dls.n_avail_feats = numel(avail_feats);
    if numel(find(sel_feats_abs)) < min_feats
        dls.is_valid = false;
        dls.dls_idx = dls_idx;
        dls.sample = full(X(dls.dls_idx,sel_feats_abs));
        dls.feats = find(sel_feats_abs);

        dls.coexp_tr = coexpression_real(dls.sample,full(X(:,sel_feats_abs)))';
        dls.coexp_tr(dls_idx) = 0;
        dls.Y_tr = Y;

        dls.score = -Inf;
        dls.scores = struct([]);
        dls.wclass0 = ones(numel(find(Y == 0)),1);    
        dls.FN_idxs = [];
        return
    else
        dls.is_valid = true;
        [s,sorted_idxs] = sort(pvals(dls_idx,:),'ascend');
        X = X(:,sorted_idxs);
        sel_feats_abs = sel_feats_abs(sorted_idxs);
        feats_sort = 1:total_feats;
        feats_sort(sorted_idxs) = feats_sort;
%         max_feats = 2*numel(find(sel_feats_abs));
        max_feats = dls.n_avail_feats;
    end
    
    w1_feats_th = round(dls.n_avail_feats*w1_feats_th_prctile/100);
	delta_w1 = (1 - min_w1)/(w1_feats_th - min_feats);
    
    [sel_feats,init_scores,wclass0_abs,FN_idxs_abs] = dls_feature_selection(X(:,sel_feats_abs),Y,dls_idx,dw/10,min_coexp,min_feats,max_feats,w1_feats_th,0,nFN,0,min_FN_coexp);
    init_sel_feats = [sel_feats false(1,total_feats - numel(sel_feats))];
    max_feats = min(round(max_feats*1.5),total_feats);
    
    if init_scores.score > 0
        [sel_feats_abs,scores_abs,wclass0_abs,FN_idxs_abs] = dls_feature_selection(X,Y,dls_idx,dw,min_coexp,min_feats,max_feats,w1_feats_th,delta_w1,nFN,0,min_FN_coexp,init_sel_feats);
		if scores_abs.score <= 0
            dw = dw/2;
%             w1_feats_th = round(w1_feats_th/2);
            delta_w1 = delta_w1/2;
            min_score_pos = 2;
			[sel_feats_abs,scores_abs,wclass0_abs,FN_idxs_abs] = dls_feature_selection(X,Y,dls_idx,dw,min_coexp,min_feats,max_feats,w1_feats_th,delta_w1,nFN,0,min_FN_coexp,init_sel_feats);            
        end
		
    else
		sel_feats_abs = init_sel_feats;
        scores_abs = init_scores;
        scores_abs.score = -Inf;
    end
	
    dls.dls_idx = dls_idx;
    dls.Y_tr = Y;
    dls.is_abs = true;
    
    dls.score = scores_abs.score;
    dls.scores = scores_abs;
    dls.wclass0 = wclass0_abs;    
    dls.FN_idxs = FN_idxs_abs;
    
    X = X(:,feats_sort);
    dls.feats = find(sel_feats_abs(feats_sort));
    dls.sample = full(X(dls.dls_idx,dls.feats));

    dls.coexp_tr = coexpression_real(dls.sample,full(X(:,dls.feats)));
    dls.coexp_tr(dls_idx) = 0;
    
    if dls.score < dls_min_score
        dls.is_valid = false;
    end
    
    if scores_abs.score_pos < min_score_pos
        dls.is_valid = false;
    end
    
    if numel(dls.feats) < min_feats
        dls.is_valid = false;
    end

end