function [F,precision,recall,nTP,nFP] = F_eval(H,Y,precW)
% [F,precision,recall,nTP,nFP] = F_eval(H,Y,precW);

    if ~exist('precW','var')
        precW = 1;
    end
    
    c1_mask = Y == 1;
    h1_mask = H == 1;
    
    nTP = numel(find(c1_mask & h1_mask));
    nFP = numel(find(~c1_mask & h1_mask));
    n1 = numel(find(c1_mask));
    
    precision = nTP/(nTP+nFP);
    recall = nTP/n1;
    
    F = (1+precW^2)/((1/recall) + (precW^2/precision));
    
end