function enrichment_analysis_DLS(results_past,actual_annot_matrix,filename)   

    n_terms = numel(results_past.conf_th);
    n_annots = zeros(n_terms,1);
    n_new_annots = zeros(n_terms,1);
    n_new_annots_in_unlab = zeros(n_terms,1);
    n_unlabeled = zeros(n_terms,1);
    n_preds = zeros(n_terms,1);
    n_preds_in_new_annots = zeros(n_terms,1);
    pval = zeros(n_terms,1);
    e_n_preds_in_new = zeros(n_terms,1);

    fid = fopen(filename,'w');
    fprintf(fid,'GO_ID\tGO_NAME\tLEVEL\tMEAN_NDIFF\tNCLASS1\tNCLASS0\tN_UNLABELED\tN_NEW_ANNOTS\tN_NEW_ANNOTS_IN_UNLAB\tN_PREDS\tN_PREDS_IN_NEW\tEXPECTED_N_PREDS_IN_NEW\tPVALUE\tCONF_TH\n');

    for i = 1:n_terms
        term_mask = actual_annot_matrix.colHeaders == results_past.go_terms.id(i);
        term_annots_mask = actual_annot_matrix.matrix(:,term_mask) == 1;
        term_annots_agis = actual_annot_matrix.rowHeaders(term_annots_mask);
        preds_agis = results_past.preds.new_agis{i}(results_past.preds.new_confs{i} > results_past.conf_th(i));
        n_preds(i) = numel(preds_agis);
        n_annots(i) = numel(term_annots_agis);
        n_new_annots(i) = numel(setdiff(term_annots_agis,results_past.go_terms.class1_agis{i}));
        n_new_annots_in_unlab(i) = numel(intersect(term_annots_agis,results_past.preds.new_agis{i}));
        n_preds_in_new_annots(i) = numel(intersect(term_annots_agis,preds_agis));
        n_unlabeled(i) = numel(results_past.preds.new_confs{i});

        p_preds = n_preds_in_new_annots(i)/n_preds(i);
        p_unlab = n_new_annots_in_unlab(i)/n_unlabeled(i);

        pval(i) = hygepdf(n_preds_in_new_annots(i),n_unlabeled(i),n_new_annots_in_unlab(i),n_preds(i));

        if p_preds < p_unlab && pval(i) < 0.5
            pval(i) = 1;
        end
        e_n_preds_in_new(i) = p_unlab*n_preds(i);

        fprintf(fid,'%d\t%s\t%d\t%.2f\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%.2f\t%.2e\t%.4f\n', ...
            results_past.go_terms.id(i),results_past.go_terms.name{i},results_past.go_terms.level(i),results_past.go_terms.mean_numDiff(i), ...
            results_past.go_terms.nclass1(i),results_past.go_terms.nclass0(i), n_unlabeled(i), n_new_annots(i), n_new_annots_in_unlab(i), n_preds(i), ...
            n_preds_in_new_annots(i), e_n_preds_in_new(i), pval(i), results_past.conf_th(i));
    end

    fclose(fid);

end