function [tr_sets,te_sets] = make_crossval_sets(Y,nfolds)
% [tr_idxs,te_idxs] = make_crossval_sets(Y,nfolds);

    te_set_p = 1/nfolds;
    
    class_idxs = find(Y == 1);
    not_class_idxs = find(Y == -1);
    
    n1 = numel(class_idxs);
    n0 = numel(not_class_idxs);
    
    nte1 = floor(n1*te_set_p);
    nte1_rest = n1 - nte1*nfolds;
    nte0 = floor(n0*te_set_p);
    nte0_rest = n0 - nte0*nfolds;
    
    class_idxs = class_idxs(randperm(n1));
    not_class_idxs = not_class_idxs(randperm(n0));
    
    tr_sets = cell(nfolds,1);
    te_sets = cell(nfolds,1);
    
    temp1 = class_idxs;
    temp0 = not_class_idxs;
    for i = 1:nfolds
        if i <= nte1_rest
            nte1_temp = nte1+1;
        else
            nte1_temp = nte1;
        end
        te_sets{i} = temp1(1:nte1_temp);
        temp1(1:nte1_temp) = [];
        tr_sets{i} = setdiff(class_idxs,te_sets{i});
        
        if i <= nte0_rest
            nte0_temp = nte0+1;
        else
            nte0_temp = nte0;
        end
        te_sets{i} = [te_sets{i}; temp0(1:nte0_temp)];
        temp0(1:nte0_temp) = [];
        tr_sets{i} = [tr_sets{i}; setdiff(not_class_idxs,te_sets{i})];
    end

end