function [tr_idxs,te_idxs] = make_holdout_sets(d,p)
% [tr_idxs,te_idxs] = holdOut(d,p);
    
    tr_idxs = []; 
    te_idxs = [];
    
    p = 1-p;
    
    idxs = find(d == 1);
    num = numel(idxs);
    num_tr = floor(p*num);
    perm = randperm(num);
    idxs_tr = idxs(perm(1:num_tr));
    idxs_te = setdiff(idxs,idxs_tr);
    tr_idxs = [tr_idxs; idxs_tr];
    te_idxs = [te_idxs; idxs_te];
    
    idxs = find(d == -1);
    num = numel(idxs);
    num_tr = floor(p*num);
    perm = randperm(num);
    idxs_tr = idxs(perm(1:num_tr));
    idxs_te = setdiff(idxs,idxs_tr);
    tr_idxs = [tr_idxs; idxs_tr];
    te_idxs = [te_idxs; idxs_te];

end