function go_terms = getRepresentativeGoTerms(GO,annot_matrix,min_annots,max_annots)
% go_terms = getRepresentativeGoTerms(GO,annot_matrix,min_annots,max_annots);
    
    go_terms.params.min_annots = min_annots;
    go_terms.params.max_annots = max_annots;
    
    go_terms.annot_matrix.aspect = annot_matrix.aspect;
    go_terms.annot_matrix.go_date = annot_matrix.go_date;
    go_terms.annot_matrix.annot_date = annot_matrix.annot_date;
    go_terms.annot_matrix.invalid_evidences = annot_matrix.invalid_evidences;
    
    go_terms.id = annot_matrix.colHeaders;
    go_terms.num_annots = full(sum(annot_matrix.matrix,1))';
    
    valid_mask = go_terms.num_annots >= min_annots & go_terms.num_annots <= max_annots;
    
    go_terms.id = go_terms.id(valid_mask);
    go_terms.num_annots = go_terms.num_annots(valid_mask);
    
    nterms = numel(go_terms.id);
    valid_mask = true(nterms,1);
    
    for i = 1:nterms
        
        if valid_mask(i)
            desc_terms = getdescendants(GO, go_terms.id(i), 'Exclude', true);
            mask = ismember(go_terms.id,desc_terms);
            valid_mask(mask) = false;
        end
        
    end
    
    go_terms.id = go_terms.id(valid_mask);
    go_terms.num_annots = go_terms.num_annots(valid_mask);
    go_terms.level = getTermsLevel(go_terms.id,GO);
    go_terms.name = get(GO(go_terms.id).terms,'name');

end