function level = getTermsLevel(go_terms,GO)
% level = getTermsLevel(go_terms,GO);
    
    num_terms = numel(go_terms);
    level = zeros(num_terms,1);
    
    for i = 1:num_terms
        go_term = go_terms(i);
        
        ancestors_go_terms = getancestors(GO, go_term);
        if numel(ancestors_go_terms) == 1
            level = 1;
            continue;
        end
        ancestorsGO = GO(ancestors_go_terms);
        matrix = getmatrix(ancestorsGO);

        if strcmp(get(ancestorsGO(go_term).Terms,'ontology'),'biological process')
            root_node = find(ismember(ancestors_go_terms,8150));
        elseif strcmp(get(ancestorsGO(go_term).Terms,'ontology'),'molecular function')
            root_node = find(ismember(ancestors_go_terms,3674));
        elseif strcmp(get(ancestorsGO(go_term).Terms,'ontology'),'cellular component')
            root_node = find(ismember(ancestors_go_terms,5575));
        else
            error('Go term %d doesnt exist in the ontology.',go_term)
        end

        target_node = find(ismember(ancestors_go_terms,go_term));    
        dist = graphshortestpath(matrix, root_node, target_node);

        level(i) = dist+1;
        
    end

end