function [terms_ids,terms_p,terms_n_in_set,terms_n_tot] = get_geneSet_terms_info(set_agis,annot_matrix)

    set_genes_mask = ismember(annot_matrix.rowHeaders,set_agis);
    set_terms_mask = any(annot_matrix.matrix(set_genes_mask,:));
    
    terms_n_tot = sum(annot_matrix.matrix(:,set_terms_mask));
    terms_n_in_set = sum(annot_matrix.matrix(set_genes_mask,set_terms_mask));
    
    terms_p = terms_n_in_set./terms_n_tot;
    
    terms_ids = annot_matrix.colHeaders(set_terms_mask);
    
    %sort results
    [terms_p,sort_idxs] = sort(terms_p,'descend');
    
    terms_ids = terms_ids(sort_idxs);
    terms_n_in_set = terms_n_in_set(sort_idxs);
    terms_n_tot = terms_n_tot(sort_idxs);

end