function terms_by_level = get_terms_by_level(ontology,GO)
% terms_by_level = terms_by_level(ontology,GO);
% Encuentra los terminos GO (GO:########) de la ontologia 'ontology'
% ('P','F','C') que se encuentran hasta el nivel 'level' del arbol de
% anotaciones. Los terminos de nivel i se entregan en anots_by_level{i}.
    
    ontologies = {'P','F','C'};
    ont_terms = [8150,3674,5575];
    
    terms_by_level{1} = ont_terms(strcmp(ontologies,ontology));
    root_num = terms_by_level{1};
    
    used_terms = root_num;
    i = 1;
    while 1
        relatives = getrelatives(GO,root_num,'Depth',i,'Height',0);
        descendants = setdiff(relatives, used_terms);
        if isempty(descendants)
            break;
        end
        terms_by_level{i+1} = descendants;
        used_terms = relatives;
        i = i + 1;
    end

end