function printCVResults(filename,results,i)
% printResults(filename,results,i);

    fid = fopen(filename,'a');
    n_cvreps = size(results.F,2);
    
    if exist('i','var')
        if i == 1
            fprintf(fid,'GO_ID\tGO_NAME\tLEVEL\tMEAN_NDIFF\tNCLASS1\tNCLASS0');
            for j = 1:n_cvreps
                fprintf(fid,'\tF%d',j);
            end
            fprintf(fid,'\tMEAN_F\tSTD_F');
            for j = 1:n_cvreps
                fprintf(fid,'\tPRECISION%d',j);
            end
            fprintf(fid,'\tMEAN_PRECISION\tSTD_PRECISION');
            for j = 1:n_cvreps
                fprintf(fid,'\tRECALL%d',j);
            end
            fprintf(fid,'\tMEAN_RECALL\tSTD_RECALL\tCONF_TH\n');
        end
        fprintf(fid,'%d\t%s\t%d\t%.2f\t%d\t%d', ...
        results.go_terms.id(i),results.go_terms.name{i},results.go_terms.level(i),results.go_terms.mean_numDiff(i), ...
        results.go_terms.nclass1(i),results.go_terms.nclass0(i));
        for j = 1:n_cvreps
            fprintf(fid,'\t%.4f',results.F(i,j));
        end
        fprintf(fid,'\t%.4f\t%.4f',mean(results.F(i,:)),std(results.F(i,:)));
        for j = 1:n_cvreps
            fprintf(fid,'\t%.4f',results.precision(i,j));
        end
        fprintf(fid,'\t%.4f\t%.4f',mean(results.precision(i,:)),std(results.precision(i,:)));
        for j = 1:n_cvreps
            fprintf(fid,'\t%.4f',results.recall(i,j));
        end
        fprintf(fid,'\t%.4f\t%.4f\t%.4f\n',mean(results.recall(i,:)),std(results.recall(i,:)),results.conf_th(i));
    else
        fprintf(fid,'GO_ID\tGO_NAME\tLEVEL\tMEAN_NDIFF\tNCLASS1\tNCLASS0');
        for j = 1:n_cvreps
            fprintf(fid,'\tF%d',j);
        end
        fprintf(fid,'\tMEAN_F\tSTD_F');
        for j = 1:n_cvreps
            fprintf(fid,'\tPRECISION%d',j);
        end
        fprintf(fid,'\tMEAN_PRECISION\tSTD_PRECISION');
        for j = 1:n_cvreps
            fprintf(fid,'\tRECALL%d',j);
        end
        fprintf(fid,'\tMEAN_RECALL\tSTD_RECALL\tCONF_TH\n');
        
        for i = 1:size(results.F,1)
            fprintf(fid,'%d\t%s\t%d\t%.2f\t%d\t%d', ...
            results.go_terms.id(i),results.go_terms.name{i},results.go_terms.level(i),results.go_terms.mean_numDiff(i), ...
            results.go_terms.nclass1(i),results.go_terms.nclass0(i));
            for j = 1:n_cvreps
                fprintf(fid,'\t%.4f',results.F(i,j));
            end
            fprintf(fid,'\t%.4f\t%.4f',mean(results.F(i,:)),std(results.F(i,:)));
            for j = 1:n_cvreps
                fprintf(fid,'\t%.4f',results.precision(i,j));
            end
            fprintf(fid,'\t%.4f\t%.4f',mean(results.precision(i,:)),std(results.precision(i,:)));
            for j = 1:n_cvreps
                fprintf(fid,'\t%.4f',results.recall(i,j));
            end
            fprintf(fid,'\t%.4f\t%.4f\t%.4f\n',mean(results.recall(i,:)),std(results.recall(i,:)),results.conf_th(i));
        end
    end
    
    fclose(fid);

end
