function printNetworkResults(networkMatrices,genes_agis,th,filename,GenesAliases)

    % delete genes without conections
    alone_rows = sum(networkMatrices.confs,2) == 0;
    alone_cols = sum(networkMatrices.confs,1) == 0;
    alone_genes = alone_rows & alone_cols';
    
    networkMatrices.confs = networkMatrices.confs(~alone_genes,~alone_genes);
    networkMatrices.confs = networkMatrices.confs - diag(diag(networkMatrices.confs));
    networkMatrices.coexps = networkMatrices.coexps(~alone_genes,~alone_genes);
    networkMatrices.coexps = networkMatrices.coexps - diag(diag(networkMatrices.coexps));
    networkMatrices.scores = networkMatrices.scores(~alone_genes,~alone_genes);
    networkMatrices.scores = networkMatrices.scores - diag(diag(networkMatrices.scores));
    genes_agis = genes_agis(~alone_genes);
    genes_names = getGenesNames(genes_agis,GenesAliases,false);
    Y = networkMatrices.Y(~alone_genes);
    
    % open file to print the network
    fid = fopen(filename,'wt');
    
    % print
    fprintf(fid,'Sign_AGI\tSign_Name\tPred_AGI\tPred_Name\tConf\tCoexp\tnFeats\tScore\tClass\n');
    n_genes = numel(genes_agis);
    for i = 1:n_genes
        
        for j = 1:n_genes
            
            if networkMatrices.confs(i,j) >= th
                if Y(j) == 2
                    class = 'new_pred';
                elseif Y(j) == 1
                    class = 'class1';
                elseif Y(j) == -1
                    class = 'class0';
                elseif Y(j) == 3
                    class = 'class1_sign';
                end
                fprintf(fid,'%s\t%s\t%s\t%s\t%.4f\t%.4f\t%d\t%.4f\t%s\n',genes_agis{i},genes_names{i},genes_agis{j},genes_names{j},full(networkMatrices.confs(i,j)),full(networkMatrices.coexps(i,j)),abs(round(full(networkMatrices.scores(i,j))/full(networkMatrices.coexps(i,j))/full(networkMatrices.confs(i,j)))),full(networkMatrices.scores(i,j)),class);
            end
            
        end
        
    end
    
    fclose(fid);

end