function print_DLS_preds(preds_results,conf_th,directory,filename,GenesAliases,Y)
%
% Y: optional. Only if predictions in training data.

    max_confs = preds_results.preds.max_confs;
    confs_sum = preds_results.preds.confs_sum;
    scores_sum = preds_results.preds.scores_sum;

    pos_idxs = find(max_confs > conf_th);
    [max_confs,sorted_idxs] = sort(max_confs(pos_idxs),'descend');
    pos_idxs = pos_idxs(sorted_idxs);

    pos_agis = preds_results.preds.genes_agis(pos_idxs);
    [pos_symbols,pos_names] = getGenesNames(pos_agis,GenesAliases,false);

    pos_confs_sum = confs_sum(pos_idxs);
    pos_scores_sum = scores_sum(pos_idxs);

    pos_dls_agis = preds_results.preds.max_confs_dls_agis(pos_idxs);
    [pos_dls_symbols,pos_dls_names] = getGenesNames(pos_dls_agis,GenesAliases,false);
    pos_dls_scores = preds_results.preds.max_confs_dls_scores(pos_idxs);
    pos_dls_n_feats = preds_results.preds.max_confs_dls_n_feats(pos_idxs);
    pos_dls_coexps = preds_results.preds.max_confs_dls_coexps(pos_idxs);
    pos_n_dls_preds = preds_results.preds.n_dls_preds(pos_idxs);

    if exist('Y','var')
        
        pos_Y = Y(pos_idxs);
        tps_idxs = find(pos_Y == 1);
        fps_idxs = find(pos_Y == -1);
        
        tps_filename = strcat(directory,filename,'_tps_results.txt');
        fid = fopen(tps_filename,'w');
        fprintf(fid,'Max_Conf\tConfs_Sum\tScores_sum\tNum_DLS_preds\tAGI\tSymbol\tName\tBest_DLS_AGI\tBest_DLS_Symbol\tBest_DLS_Name\tBest_DLS_coexp\tBest_DLS_n_feats\tBest_DLS_Score\n');
        for j = 1:numel(tps_idxs)
            i = tps_idxs(j);
            fprintf(fid,'%.4f\t%.2f\t%.2f\t%d\t%s\t%s\t%s\t%s\t%s\t%s\t%.4f\t%d\t%.2f\n',max_confs(i),pos_confs_sum(i),pos_scores_sum(i),pos_n_dls_preds(i),pos_agis{i},pos_symbols{i},pos_names{i},pos_dls_agis{i},pos_dls_symbols{i},pos_dls_names{i},pos_dls_coexps(i),pos_dls_n_feats(i),pos_dls_scores(i));
        end
        fclose(fid);
        fprintf('\nTraining true positive details saved in:\n%s',tps_filename);
        
        fps_filename = strcat(directory,filename,'_fps_results.txt');
        fid = fopen(fps_filename,'w');
        fprintf(fid,'Max_Conf\tConfs_Sum\tScores_sum\tNum_DLS_preds\tAGI\tSymbol\tName\tBest_DLS_AGI\tBest_DLS_Symbol\tBest_DLS_Name\tBest_DLS_coexp\tBest_DLS_n_feats\tBest_DLS_Score\n');
        for j = 1:numel(fps_idxs)
            i = fps_idxs(j);
            fprintf(fid,'%.4f\t%.2f\t%.2f\t%d\t%s\t%s\t%s\t%s\t%s\t%s\t%.4f\t%d\t%.2f\n',max_confs(i),pos_confs_sum(i),pos_scores_sum(i),pos_n_dls_preds(i),pos_agis{i},pos_symbols{i},pos_names{i},pos_dls_agis{i},pos_dls_symbols{i},pos_dls_names{i},pos_dls_coexps(i),pos_dls_n_feats(i),pos_dls_scores(i));
        end
        fclose(fid);
        fprintf('\nTraining false positive details saved in:\n%s',fps_filename);
        
    else
        
        filename = strcat(directory,filename,'.txt');
        fid = fopen(filename,'w');
        fprintf(fid,'Max_Conf\tConfs_Sum\tScores_sum\tNum_DLS_preds\tAGI\tSymbol\tName\tBest_DLS_AGI\tBest_DLS_Symbol\tBest_DLS_Name\tBest_DLS_coexp\tBest_DLS_n_feats\tBest_DLS_Score\n');
        for i = 1:numel(pos_idxs)
            fprintf(fid,'%.4f\t%.2f\t%.2f\t%d\t%s\t%s\t%s\t%s\t%s\t%s\t%.4f\t%d\t%.2f\n',max_confs(i),pos_confs_sum(i),pos_scores_sum(i),pos_n_dls_preds(i),pos_agis{i},pos_symbols{i},pos_names{i},pos_dls_agis{i},pos_dls_symbols{i},pos_dls_names{i},pos_dls_coexps(i),pos_dls_n_feats(i),pos_dls_scores(i));
        end
        fclose(fid);
        fprintf('\nPositive predictions details saved in:\n%s',filename);
        
    end
    
end