function print_DLS_signatures(tr_results,filename,GenesAliases,corr_th)

    if nargin < 4
        corr_th = 0.7;
    end
    
    n_sign = tr_results.n_valid_dls;
    sign_idxs = find(tr_results.valid_dls_mask);
    sign_agis = tr_results.genes_agis(tr_results.dls_idxs(sign_idxs));
    [sign_symbols,sign_names] = getGenesNames(sign_agis,GenesAliases,false);
    
    fid = fopen(filename,'w');

    fprintf(fid,'Signature AGI\tSignature Symbol\tSignature Name\tNum Available Features\tNum Selected Features\tScore\tPositive Score\tNegative Score\tNum Pos Corrs>%.2f\tNum Neg Corrs>%.2f\n',corr_th,corr_th);
    for i = 1:n_sign
        sign_idx = sign_idxs(i);
        n_pos_corr = sum(abs(tr_results.dls{sign_idx}.coexp_tr(tr_results.Y_tr == 1)) > corr_th);
        n_neg_corr = sum(abs(tr_results.dls{sign_idx}.coexp_tr(tr_results.Y_tr == -1)) > corr_th);
        fprintf(fid,'%s\t%s\t%s\t%d\t%d\t%.4f\t%.4f\t%.4f\t%d\t%d\n',sign_agis{i},sign_symbols{i},sign_names{i}, ...
        tr_results.dls_n_avail_feats(sign_idx),tr_results.dls_n_feats(sign_idx),tr_results.dls{sign_idx}.scores.score, ...
        tr_results.dls{sign_idx}.scores.score_pos,tr_results.dls{sign_idx}.scores.score_neg, ...
        n_pos_corr,n_neg_corr);
    end
    fclose(fid);

end