function nbors_matrix = getNbors_from_vector_cutoff(corrs_vector,rows_idxs,matrix_size,corr_cutoff)

    nr = numel(rows_idxs);
    n = matrix_size;
    nbors_matrix = false(nr,matrix_size);
    tic
    for i = 1:nr
        idx = rows_idxs(i);
        
        lower_idxs = 1:idx-1;
        corrs = corrs_vector(n.*(lower_idxs-1)+idx-lower_idxs.*(lower_idxs+1)/2);
        mask = corrs >= corr_cutoff;
        lower_idxs = lower_idxs(mask);
        nbors_matrix(i,lower_idxs) = true;
        
        upper_idxs = idx+1:n;
        corrs = corrs_vector(n*(idx-1)+upper_idxs-idx*(idx+1)/2);
        mask = corrs >= corr_cutoff;
        upper_idxs = upper_idxs(mask);
        nbors_matrix(i,upper_idxs) = true;
        if mod(i,1000) == 0
            t = toc;
            fprintf('Row %d/%d. Elapsed time: %.1f mins. Time left: %.1f mins\n',i,nr,t/60,(nr-i)*t/i/60)
        end
    end
    
end
