function [w1,gamma] = getParamsSVM(X, Y)
    
    n1 = numel(find(Y==1));
    n0 = numel(find(Y==-1));
    w1 = ceil(0.1*n0/n1);
    
    if nargout == 2
        % get nearest negative sample for each positive sample
        dists = pdist2(X(Y==1,:),X(Y==-1,:));
        min_dists = min(dists,[],2);
        alpha = median(min_dists);
        gamma = 1/(2*alpha^2);
    end

end