function [X,Y,genes_agis_X,pvals] = makeXY(DataMatrix,class1_agis,class0_agis,genes_agis,pvals)
% [X,Y,genes_agis_X] = makeXY(DataMatrix,class1_agis,class0_agis,genes_agis);

    nc1 = numel(class1_agis);
    nc0 = numel(class0_agis);
    
    [tf,class1_idxs] = ismember(class1_agis,genes_agis);
    [tf,class0_idxs] = ismember(class0_agis,genes_agis);
    
    X = [DataMatrix(class1_idxs,:); DataMatrix(class0_idxs,:)];
    Y = [ones(nc1,1); -1*ones(nc0,1)];
    
    genes_agis_X = [class1_agis; class0_agis];
    
    if nargin > 4 && nargout > 3
        pvals = [pvals(class1_idxs,:); pvals(class0_idxs,:)];
    end
    
end
