% Script that runs all the test done for the Bioinformatics paper:
% Discriminative local subspaces in gene expression data for effective gene
% function prediction. Results are saved in the "Results" directory.

%% Obtains the representative go-terms training sets
clear, Paper_test_1_Representative_GO_terms_script

%% Uses the FND method to correct false negatives in training sets
clear, Paper_test_2_FND_script

%% Runs cross-validation test over DLS
clear, Paper_test_3_DLS_CV_script

%% Runs cross-validation test over FND-DLS
clear, Paper_test_4_DLS_FND_CV_script

%% Runs enrichment test over DLS
clear, Paper_test_5_DLS_Enrichment_script

%% Runs enrichment test over FND-DLS
clear, Paper_test_6_DLS_FND_Enrichment_script

%% Runs cross-validation test over CN
clear, Paper_test_7_CN_CV_script

%% Runs the enrichment test over CN
clear, Paper_test_8_CN_Enrichment_script

%% Runs cross-validation test over Linear-SVM
clear, Paper_test_9_SVM_Linear_CV_script

%% Runs the enrichment test over Linear-SVM
clear, Paper_test_10_SVM_Linear_Enrichment_script

%% Runs cross-validation test over RBF-SVM
clear, Paper_test_11_SVM_RBF_CV_script

%% Runs the enrichment test over RBF-SVM
clear, Paper_test_12_SVM_RBF_Enrichment_script

%% Runs the enrichment test over DLS using the automated-matrix with 1000 features
clear, Paper_test_13_Autom1000_DLS_Enrichment_script

%% Runs the enrichment test over DLS using the automated-matrix with 2000 features
clear, Paper_test_14_Autom2000_DLS_Enrichment_script

%% Runs the enrichment test over DLS using the automated-matrix with all features
clear, Paper_test_15_Autom3911_DLS_Enrichment_script

%% Runs the enrichment test over CN using the automated-matrix with 1000 features
clear, Paper_test_16_Autom1000_CN_Enrichment_script

%% Runs the enrichment test over CN using the automated-matrix with 2000 features
clear, Paper_test_17_Autom2000_CN_Enrichment_script

%% Runs the enrichment test over CN using the automated-matrix with all features
clear, Paper_test_18_Autom3911_CN_Enrichment_script

%% Runs the enrichment test over Linear-SVM using the automated-matrix with 1000 features
clear, Paper_test_19_Autom1000_SVM_Linear_Enrichment_script

%% Runs the enrichment test over Linear-SVM using the automated-matrix with 2000 features
clear, Paper_test_20_Autom2000_SVM_Linear_Enrichment_script

%% Runs the enrichment test over Linear-SVM using the automated-matrix with all features
clear, Paper_test_21_Autom3911_SVM_Linear_Enrichment_script

%% Runs the enrichment test over RBF-SVM using the automated-matrix with 1000 features
clear, Paper_test_22_Autom1000_SVM_RBF_Enrichment_script

%% Runs the enrichment test over RBF-SVM using the automated-matrix with 2000 features
clear, Paper_test_23_Autom2000_SVM_RBF_Enrichment_script

%% Runs the enrichment test over RBF-SVM using the automated-matrix with all features
clear, Paper_test_24_Autom3911_SVM_RBF_Enrichment_script

